#version 430 core
layout(location = 0) out vec4 frag_color;
  
in vec2 texture_uv;

layout(location = 110) uniform sampler2D texture_to_blur;
layout(location = 119) uniform bool horizontal;

const float gauss[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

void main()
{             
    vec2 texel_size = 1.0 / textureSize(texture_to_blur, 0);
    vec3 result = texture(texture_to_blur, texture_uv).rgb * gauss[0];
    if(horizontal)
    {
        for(int i = 1; i < 5; ++i)
        {
            result += texture(texture_to_blur, texture_uv + vec2(texel_size.x * i, 0.0)).rgb * gauss[i];
            result += texture(texture_to_blur, texture_uv - vec2(texel_size.x * i, 0.0)).rgb * gauss[i];
        }
    }
    else
    {
        for(int i = 1; i < 5; ++i)
        {
            result += texture(texture_to_blur, texture_uv + vec2(0.0, texel_size.y * i)).rgb * gauss[i];
            result += texture(texture_to_blur, texture_uv - vec2(0.0, texel_size.y * i)).rgb * gauss[i];
        }
    }
    frag_color = vec4(result, 1.0);
}