#version 430

layout(location = 0) out vec4 frag_color;

layout(location = 110) uniform sampler2D texture_hdr;//diffuse-slot
layout(location = 111) uniform sampler2D texture_bloom;//specular-slot
layout(location = 119) uniform bool use_bloom;

in vec2 texture_uv;

void main()
{             
    const float gamma = 1.0f;
    const float exposure = 1.0f;

    frag_color = texture(texture_hdr, texture_uv);
    if(use_bloom) frag_color = frag_color+texture(texture_bloom, texture_uv);
  
    // tone mapping
    frag_color = vec4(1.0) - exp(-frag_color * exposure);
    // gamma 
    frag_color = pow(frag_color, vec4(1.0 / gamma));
} 