#version 430

layout(location = 0) out vec4 frag_color;
layout(location = 1) out vec4 bloom_color;

#import lighting_uniforms.glsl

layout(location = 110) uniform sampler2D texture_diffuse;
layout(location = 111) uniform sampler2D texture_specular;

layout(location = 119) uniform bool has_environment;
layout(location = 120) uniform samplerCube texture_environment;

in vec3 normal_world;
in vec3 position_world;
in vec2 texture_uv;
in vec4 position_light[3];

vec3 textureColorDiffuse(){
   return texture(texture_diffuse, texture_uv).rgb;
}

vec3 textureColorSpecular(){
   return texture(texture_specular, texture_uv).rgb;
}

vec3 calculateEnvironment(vec3 viewVector){
    vec3 cubeMapCoord = reflect(-viewVector, normalize(normal_world));
    return texture(texture_environment, cubeMapCoord).rgb;
}

#import lighting_functions.glsl

void main () {
    vec3 v = normalize(cameraPosition-position_world);
    vec4 lights = calculateLights(v);
    /*if(has_environment){
        vec4 environment = vec4(calculateEnvironment(v),0);
        frag_color = lights + environment*ks;
    } else {*/
        frag_color = lights;
    //}
    frag_color.a = opacity;

    float brightness = dot(frag_color.rgb, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 0.9)
        bloom_color = vec4(frag_color.rgb, opacity);
    else
        bloom_color = vec4(0.0, 0.0, 0.0, 1.0);
}