#version 430

layout(location = 0) out vec4 frag_color;
layout(location = 1) out vec4 bloom_color;

#import lighting_uniforms.glsl


in vec3 normal_world;
in vec3 position_world;
in vec4 position_light[3];

vec3 textureColorDiffuse(){
   return color;
}

vec3 textureColorSpecular(){
   return color;
}

#import lighting_functions.glsl

void main () {
    vec3 v = normalize(cameraPosition-position_world);
    frag_color = calculateLights(v);
    frag_color.a = opacity;

    float brightness = dot(frag_color.rgb, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 0.9)
        bloom_color = vec4(frag_color.rgb, opacity);
    else
        bloom_color = vec4(0.0, 0.0, 0.0, 1.0);
}