#version 430

layout (points) in;
layout (triangle_strip) out;
layout (max_vertices = 4) out;

layout(location = 5) uniform mat4 vp;
layout(location = 6) uniform float aspectRatio;
layout(location = 40) uniform vec3 cameraPosition;

out vec2 texture_uv;

void main()
{
    vec4 position = vp * gl_in[0].gl_Position;

    float sizeFactor = 0.5;
    vec3 up = vec3(0.0, sizeFactor, 0.0);
    vec3 right = vec3(sizeFactor/aspectRatio, 0.0, 0.0);
    //note about aspectRatio: doing this in clip space to avoid seperately multiplying view and projection matrices means the quad would be distorted, this fixes that

    vec3 leftUp =    position.xyz-right+up;
    vec3 rightUp =   position.xyz+right+up;
    vec3 leftDown =  position.xyz-right-up;
    vec3 rightDown = position.xyz+right-up;

    gl_Position = vec4(leftDown, position.w);
    texture_uv = vec2(0.0, 0.0);
    EmitVertex();

    gl_Position = vec4(rightDown, position.w);
    texture_uv = vec2(1.0, 0.0);
    EmitVertex();

    gl_Position = vec4(leftUp, position.w);
    texture_uv = vec2(0.0, 1.0);
    EmitVertex();

    gl_Position = vec4(rightUp, position.w);
    texture_uv = vec2(1.0, 1.0);
    EmitVertex();

    EndPrimitive();
}