layout(location = 1) uniform vec3 color;
layout(location = 3) uniform float opacity;
layout(location = 4) uniform float ambientPower;

layout(location = 20) uniform float ka;
layout(location = 21) uniform float kd;
layout(location = 22) uniform float ks;
layout(location = 23) uniform int alpha;


struct DirectionalLight {
    vec3 direction;
    vec3 color;
};  
layout(location = 30) uniform DirectionalLight directionals[3];

layout(location = 40) uniform vec3 cameraPosition;
layout(location = 45) uniform sampler2D shadowMap;

struct PointLight {
    vec3 color;
    vec3 position;

    float attenuationConstant;
    float attenuationLinear;
    float attenuationQuadratic;
};
layout(location = 50) uniform PointLight pointLights[3];

struct SpotLight {
    vec3 color;
    vec3 position;
    vec3 direction;

    float angleInner;
    float angleOuter;

    vec3 attenuation; //attenuationConstant, attenuationLinear, attenuationQuadratic;

    bool shadows;
    mat4 light_vp;
};
layout(location = 70) uniform SpotLight spotLights[3];

layout(location = 100) uniform int numDirectional;
layout(location = 101) uniform int numPoint;
layout(location = 102) uniform int numSpot;
