function win()
	viewTargets = registry:runtime_view(TargetComponent, NameComponent, HealthComponent)
	viewTargets:each(function(e)
		targetName = registry:get(e, NameComponent).name
		targetHealth = registry:get(e, HealthComponent).name
		print("Destroying ",targetName," for the win")
		targetHealth.health=0
		targetHealth.destroyed=true
		destroy(name)
	end)
end

function setHealth(newHealth, playerNumber)
	playerEntity = getPlayerEntityByNumber(playerNumber)
	healthC = registry:get(playerEntity, HealthComponent)
	healthC.health = newHealth
	if newHealth == 0 then healthC.destroyed = true end
end

function getPlayerEntityByNumber(playerNumber)
	playerNumber = playerNumber or 1;
	viewPlayer = registry:runtime_view(PlayerComponent)
	result = -1
	viewPlayer:each(function(e)
		if registry:get(e, PlayerComponent).playerNumber == playerNumber then
			result = e
		end
	end)
	if(result == -1) then 
		error("Player " .. playerNumber .. " not found")
	end
	return result
end

function godMode(playerNumber)
	playerEntity = getPlayerEntityByNumber(playerNumber)
	healthC = registry:get(playerEntity, HealthComponent)
	healthC.invincible = not healthC.invincible
end

function destroy(name)
	print("Called destroy for ",name)
	view = registry:runtime_view(NameComponent,HealthComponent)
	view:each(function(entity)
		entityName = registry:get(entity, NameComponent).name
		if(entityName == name) then
			healthC = registry:get(entity, HealthComponent)
			healthC.health = 0
			healthC.destroyed = true
		end
	end)
end

function aWA(weaponID, amount, playerNumber)
	addWeaponAmmo(weaponID, amount, playerNumber)
end
function addWeaponAmmo(weaponID, amount, playerNumber)
	playerEntity = getPlayerEntityByNumber(playerNumber)
	weapons = registry:get(playerEntity, WeaponsComponent).weapons
	for i, weapon in ipairs(weapons) do
		template = weapon:template()
		if(template.id == weaponID and template.limitedAmmo) then
			weapon.ammo = weapon.ammo + amount
		end
	end
end

 -- the following functions are for use in an artifact, "entity" is set by LuaCore
function addWeaponAmmoForEntity(weaponID, amount)
	playerEntity = getPlayerEntityByNumber(playerNumber)
	weapons = registry:get(playerEntity, WeaponsComponent).weapons
	for i, weapon in ipairs(weapons) do
		template = weapon:template()
		if(template.id == weaponID and template.limitedAmmo) then
			weapon.ammo = weapon.ammo + amount
		end
	end
end
function godModeForEntity()
	registry:get(entity, HealthComponent).invincible = true
end
