#version 430

layout(location = 0) in vec3 position;
layout(location = 1) uniform vec3 color;
layout(location = 2) in vec3 normal;
layout(location = 3) in vec2 texture_uv_in;
layout(location = 5) uniform mat4 vp;
layout(location = 15) uniform mat4 model;

struct SpotLight {
    vec3 color;
    vec3 position;
    vec3 direction;

    float angleInner;
    float angleOuter;

    vec3 attenuation; //attenuationConstant, attenuationLinear, attenuationQuadratic;

    bool shadows;
    mat4 light_vp;
};
layout(location = 70) uniform SpotLight spotLights[3];

out vec3 position_world;
out vec3 normal_world;
out vec2 texture_uv;
out vec4 position_light[3];

void main(){
    gl_Position = vp * model * vec4(position, 1);

    position_light[0] = spotLights[0].light_vp * model * vec4(position, 1);
    position_light[1] = spotLights[1].light_vp * model * vec4(position, 1);
    position_light[2] = spotLights[2].light_vp * model * vec4(position, 1);

    position_world = (model * vec4(position, 1)).xyz; 
    normal_world = (transpose(inverse(model)) * vec4(normal, 1)).xyz;
    texture_uv = texture_uv_in;
}